/*
 *	Title:		Lohacker Mansion
 *	Version:	Beta
 *	Created by:	Paolo Copello
 *	Home page:	http://web.tiscali.it/fanelia
 *	
 *	Copyright (C) 2003 Paolo Copello
 *	
 *	******************************************
 *	This file is part of Lohacker Mansion
 *	******************************************
 *	
 *	Lohacker Mansion is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	any later version.
 *	
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	
 */


// suppress "truncated debug info" warnings (VC++ specific)
#ifdef _MSC_VER
#pragma warning (disable: 4786)
#pragma warning (disable: 4788)
#endif // _MSC_VER


#include "Lohacker.h"

Lohacker::Lohacker()
{
	/*bGrifondoro = false;*/
}

Lohacker::~Lohacker()
{

}

void Lohacker::OnTitle()
{
	Io().Write("---                                     ---\n");
	Io().Write("---        LOHACKER  MANSION            ---\n");
	Io().Write("---             ovvero                  ---\n");
	Io().Write("--- ALLA RICERCA DELLA MISSIONE PERDUTA ---\n");
	Io().Write("---                                     ---\n");
	Io().Write("Versione Beta\n");
	Io().Write("Copyright (C) 2003 Paolo Copello\n\n\n");
}

void Lohacker::OnStart()
{
	Io().WriteLine();
	Io().Write("----------------------------------------------------------------------\n");
	Io().Write("- ... dunque, te la senti di accettare la missione?\n");
	Io().Write("\nDi colpo apri gli occhi e ti ricordi dove sei: su una scomodissima\n"
				"poltrona, nell'ufficio privato del Conte Ugolinux, tuo mentore.\n");
	Io().WaitForEnter();
	Io().Write("- Certo che accetto! - rispondi deciso. Ultimamente il Conte sembra fare\n"
				"molto affidamento su di te, e non vuoi deluderlo.\n"
				"Sara' la solita passeggiata, poco pericolo e tanta gloria.\n");
	Io().WaitForEnter();
	Io().Write("- Bene, buona fortuna! - dice il conte, e schiocca le dita.\n"
				"Improvvisamente il tuo corpo inizia a diventare trasparente.\n"
				"- Ahhh! Ma che mi sta facendo?\n");
	Io().WaitForEnter();
	Io().Write("- Teletrasporto, no? Te l'ho spiegato prima! Ora vai, e riporta indietro\n"
				"sano e salvo il nostro am...\n");
	Io().Write("- Aspetti, eccellenza, mi puo' rispiegare la miss...\n");
	Io().WaitForEnter();
	Io().Write("*ZOT!*\n\n"
			"Troppo tardi. Il Conte sparisce e ti ritrovi nell'atrio di una villa nobiliare,\n"
			"senza neanche sapere qual'e' la tua missione. Cosi' impari a dormire!\n");
	Io().WaitForEnter();

	MoveTo(INGRESSO);
}


void Lohacker::OnInit(AvDesigner& design)
{
	InitDefaultItaliano(design);

	design.AddLocation(CUCINA, "Sei nella cucina.", 
		"Ti trovi in una cucina di modeste dimensioni. Niente di eccezionale, direi.",
		INGRESSO, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID);

	design.AddLocation(INGRESSO, "Sei nell'atrio.", 
		"L'atrio della villa e' veramente immenso. Affreschi variopinti adornano\n"
		"il soffitto, e una straordinaria pianta di ficus fa bella mostra di se'.\n"
		"A sud c'e' quella che sembra una piccola cucina, a nord uno sgabuzzino,\n"
		"a est l'uscita. Una scala maestosa sale verso l'alto, mentre davanti a te,\n"
		"verso ovest, si trova un portale riccamente decorato.\n"
		"C'e' un cane dall'aspetto feroce che fa la guardia.",
		DISPENSA, CUCINA, AV_INVALID, LOVE_ROOM, PIANEROTTOLO, AV_INVALID);

	design.AddLocation(DISPENSA, "Sei nella dispensa.", 
		"Una squallida dispensa, o sgabuzzino che dir si voglia.",
		AV_INVALID, INGRESSO, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID);
	
	design.AddLocation(LOVE_ROOM, "Sei nella Sala Azzurra.", 
		"Questo doveva essere un tempo un salone sontuoso, ma oggi sembra in rovina.\n"
		"Le pareti sono decorate con strani disegni geometrici, la tinta dominante e'\n"
		"l'azzurro. In un angolo della stanza c'e' una specie di cella.\n\n"
		"All'angolo opposto c'e' un paravento, il cui rosso fuoco stona molto \n"
		"con il resto dell'ambiente.",
		AV_INVALID, AV_INVALID, INGRESSO, AV_INVALID, AV_INVALID, AV_INVALID);

	design.AddLocation(PIANEROTTOLO, "Sei nel pianerottolo.", 
		"Sei in un pianerottolo. A nord c'e' una porta con scritto 'Studio'.",
		STUDIO, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID, INGRESSO);

	design.AddLocation(STUDIO, "Sei nello studio.", 
		"Non ci sono dubbi, sei nello studio. Da cosa l'hai capito? Dall'austerita'\n"
		"dell'ambiente? Dalla scrivania in legno pregiato?\n"
		"O forse dalla scritta sulla porta?",
		AV_INVALID, PIANEROTTOLO, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID);

	design.AddTerm(POLLO, "pollo");
	design.AddTerm(CHIAVE, "chiave");
	design.AddTerm(PORTA, "porta");
	design.AddTerm(PORTALE, "portale");
	design.AddTerm(ARMADIO, "armadio dispensa credenza");
	design.AddTerm(LIBRO, "libro");
	design.AddTerm(LEGGI, "leggi sfoglia");

	design.AddTerm(_GNU, "gnu");
	design.AddTerm(_NOT, "not");
	design.AddTerm(_UNIX, "unix");

	design.AddTerm(CELLA, "cella gabbia prigione");
	design.AddTerm(SPARA, "spara");

	design.AddTerm(FICUS, "ficus");
	design.AddTerm(CANE, "cane cagnolino bau cucciolo pitbull");
	design.AddTerm(ACCAREZZA, "accarezza carezza coccola");

	design.AddTerm(CUOCI, "cucina cuoci prepara arrostisci");

	design.AddTerm(PISTOLA, "pistola rivoltella");
	design.AddTerm(ESTRAI, "estrai impugna");
	design.AddTerm(RIPONI, "riponi nascondi");
	design.AddTerm(METTI, "metti mettiti");
	design.AddTerm(TASCA, "tasca tasche");
	
	design.AddTerm(SCHIFIDO, "gatto micio schifido schifoso lamer");
	design.AddTerm(TUX, "tux tuxenstein pinguino");

	design.AddTerm(PARAVENTO, "paravento");
	design.AddTerm(NASCONDITI, "nasconditi");

	design.AddTerm(LOGICIEL, "logiciel");
	design.AddTerm(LIBRE, "libre");

	design.AddExcludeWords("col nello nella is s dietro");
	
	/**** PRIMA PARTE - esplorazione della casa ****/

	// il libro
	design.AddObject(LIBRO, "un libro", "Un manoscritto polveroso, dall'aspetto antico.", 
		STUDIO, false);
	ACTION_VERB_NOUN(AV_ANY_PLACE, APRI, LIBRO, &Lohacker::OnApriLibro);
	ACTION_VERB_NOUN(AV_ANY_PLACE, LEGGI, LIBRO, &Lohacker::OnApriLibro);

	// il pollo
	design.AddObject(POLLO, "un pollo", "Un pollo di prima scelta. Crudo, purtroppo.", AV_LIMBO, false);
	design.AddStateToObject(POLLO, COTTO, "un pollo arrosto", "Sembra molto appetitoso...");

	ACTION_VERB_NOUN(AV_ANY_PLACE, MANGIA, POLLO, &Lohacker::OnMangiaPollo);

	design.AddTimer(TIMER_POLLO);
	design.AddStateToObject(POLLO, IN_COTTURA, "un pollo che sta cuocendo", 
		"Non vedi l'ora che sia pronto, eh?");
	ACTION_TIMER_ELAPSED(TIMER_POLLO, &Lohacker::OnPolloPronto);

	// prendere il pollo in cucina potrebbe non essere possibile...
	ACTION_VERB_NOUN ( CUCINA, PRENDI, POLLO, &Lohacker::OnPrendiPolloInCucina );

	// sovrascrive il comportamento di default di "ASPETTA"
	ACTION_VERB (AV_ANY_PLACE, ASPETTA, &Lohacker::OnAspettaSpecial );

	// cottura del pollo
	ACTION_VERB_NOUN ( CUCINA, CUOCI, POLLO, &Lohacker::OnCuociPollo);
	ACTION_VERB_NOUN ( AV_ANY_PLACE, CUOCI, POLLO, "Non e' questo il luogo giusto per cucinare!");
	ACTION_VERB_NOUN ( AV_ANY_PLACE, CUOCI, AV_ANY_TERM, "Non dire sciocchezze.");
	ACTION_VERB ( AV_ANY_PLACE, CUOCI, "Che cosa?");

	// chiavi, porte ed altro
	design.AddObject(CHIAVE, "una chiave", "Lucida, pulita... austera. Come solo una chiave puo' esserlo!\nChissa' che porta apre...", AV_LIMBO, false, AvObject::THING);

	design.AddObject(PORTA, "una porta", "Austera... come solo una porta puo' esserlo!.", PIANEROTTOLO, true);
	design.AddStateToObject(PORTA, APERTA, "una porta aperta", "Dalla porta vedi lo studio.");

	design.AddObject(PORTALE, "un portale", "Grande, grandissimo, smisurato.\n"
		"Ci sono delle scritte in una lingua incomprensibile.", INGRESSO, true);
	design.AddStateToObject(PORTALE, APERTA, "un portale aperto", "Dal portale vedi una sala azzurra.");

	// apertura per le due porte
	ACTION_VERB_NOUN ( INGRESSO, APRI, PORTALE, "E' chiuso, e non ci sono serrature.");
	ACTION_VERB_NOUN ( PIANEROTTOLO, APRI, PORTA, &Lohacker::OnApriStudio);
	ACTION_THREE ( PIANEROTTOLO, APRI, PORTA, CHIAVE, &Lohacker::OnApriStudio);
	ACTION_THREE ( PIANEROTTOLO, USA_COSA, CHIAVE, PORTA, &Lohacker::OnApriStudio);

	design.AddObject(ARMADIO, "un armadio", "L'armadio della dispensa e' vecchio e tarlato.", DISPENSA, true, AvObject::THING);
	design.AddStateToObject(ARMADIO, APERTA, "un armadio aperto", "L'armadio della dispensa e' vecchio e tarlato... anche dentro!");
	ACTION_VERB_NOUN (DISPENSA, APRI, ARMADIO, &Lohacker::OnApriArmadio);

	// il ficus e il cane
	design.AddObject(FICUS, "un ficus", "", INGRESSO, true, AvObject::PLANT);
	ACTION_VERB_NOUN (INGRESSO, GUARDA, FICUS, &Lohacker::OnGuardaFicus);
	ACTION_VERB_NOUN (INGRESSO, LEGGI, FICUS, &Lohacker::OnGuardaFicus);

	design.AddObject(CANE, "un cane", "Pitbull, il cane piu' pericoloso del mondo.\n"
		"Anche se e' molto giovane, ti incute non poca fifa.", INGRESSO, true, AvObject::ANIMAL);

	ACTION_VERB (AV_ANY_PLACE, ACCAREZZA, "Chi? Che cosa?");
	ACTION_VERB_NOUN (AV_ANY_PLACE, ACCAREZZA, CANE, &Lohacker::OnCoccoleCane);
	ACTION_VERB_NOUN (AV_ANY_PLACE, ACCAREZZA, AV_ANY_TERM, "Ma che stai dicendo?");

	/**** SECONDA PARTE - la sfida dello Schifido ****/

	// la CELLA
	design.AddObject(CELLA, "una cella", "La cella e' completamente in ombra: guardi attraverso le sbarre, ma\n"
		"non riesci a vedere niente.\nPero' senti, ogni tanto, una specie di verso che ti da' i brividi...", 
		LOVE_ROOM, true);
	ACTION_VERB_NOUN (LOVE_ROOM, APRI, CELLA, "E' chiusa con un pesante lucchetto. Non riesci ad aprirla.");
	ACTION_THREE (LOVE_ROOM, APRI, CELLA, CHIAVE, "Non e' la chiave giusta.");
	ACTION_THREE (LOVE_ROOM, USA_COSA, CHIAVE, CELLA, "Non e' la chiave giusta.");
	ACTION_VERB_NOUN (LOVE_ROOM, SPARA, CELLA, "Non mi fido. Non so chi ci sia dentro.");
	ACTION_THREE (LOVE_ROOM, USA_COSA, PISTOLA, CELLA, "Non mi fido. Non so chi ci sia dentro.");

	// parole magiche
	ACTION_THREE (AV_ANY_PLACE, _GNU, _NOT, _UNIX, &Lohacker::OnGrifondoro);
	design.AddIntegerVariable(CONOSCI_GRIFONDORO, 0);

	ACTION_VERB_NOUN (AV_ANY_PLACE, LOGICIEL, LIBRE, &Lohacker::OnLogicielLibre);
	design.AddIntegerVariable(CONOSCI_LIBRE, 0);

	// la pistola
	design.AddObject(PISTOLA, "una rivoltella", "E' carica e letale.", STUDIO, false, AvObject::THING);
	design.AddIntegerVariable(PISTOLA_IN_PUGNO, 0);

	// lo schifido
	design.AddObject(SCHIFIDO, "lo Schifido", "Con quella sua faccia da gatto, lo Schifido e' il peggiore dei lamer:\nuna bestia infida e pericolosa.", AV_LIMBO, true, AvObject::PERSON);

	// azioni che possono uccidere lo schifido
	ACTION_VERB_NOUN ( LOVE_ROOM, SPARA, SCHIFIDO, &Lohacker::OnSparaSchifido);
	ACTION_VERB_NOUN ( LOVE_ROOM, UCCIDI, SCHIFIDO, &Lohacker::OnAttaccaSchifido);
	ACTION_VERB_NOUN ( LOVE_ROOM, ATTACCA, SCHIFIDO, &Lohacker::OnAttaccaSchifido);
	ACTION_THREE ( LOVE_ROOM, USA_COSA, PISTOLA, SCHIFIDO, &Lohacker::OnSparaSchifido);

	ACTION_THREE ( LOVE_ROOM, SPARA, SCHIFIDO, SCHIFIDO, &Lohacker::OnSparaSchifido);
	ACTION_THREE ( LOVE_ROOM, UCCIDI, SCHIFIDO, SCHIFIDO, &Lohacker::OnAttaccaSchifido);
	ACTION_THREE ( LOVE_ROOM, ATTACCA, SCHIFIDO, SCHIFIDO, &Lohacker::OnAttaccaSchifido);
	ACTION_THREE ( LOVE_ROOM, SPARA, SCHIFIDO, PAROLACCIA, &Lohacker::OnSparaSchifido);
	ACTION_THREE ( LOVE_ROOM, UCCIDI, SCHIFIDO, PAROLACCIA, &Lohacker::OnAttaccaSchifido);
	ACTION_THREE ( LOVE_ROOM, ATTACCA, SCHIFIDO, PAROLACCIA, &Lohacker::OnAttaccaSchifido);

	// il pinguino e le azioni che possono ucciderlo
	design.AddObject(TUX, "Tuxenstein il pinguino", 
		"Questo mostro ha un aspetto vagamente familiare...", AV_LIMBO, true, AvObject::ANIMAL);

	ACTION_VERB_NOUN ( LOVE_ROOM, SPARA, TUX, &Lohacker::OnSparaTux);
	ACTION_VERB_NOUN ( LOVE_ROOM, UCCIDI, TUX, &Lohacker::OnAttaccaTux);
	ACTION_VERB_NOUN ( LOVE_ROOM, ATTACCA, TUX, &Lohacker::OnAttaccaTux);
	ACTION_THREE ( LOVE_ROOM, USA_COSA, PISTOLA, TUX, &Lohacker::OnSparaTux);
	ACTION_THREE ( LOVE_ROOM, SPARA, TUX, TUX, &Lohacker::OnSparaTux);
	ACTION_THREE ( LOVE_ROOM, UCCIDI, TUX, TUX, &Lohacker::OnAttaccaTux);
	ACTION_THREE ( LOVE_ROOM, ATTACCA, TUX, TUX, &Lohacker::OnAttaccaTux);

	// sparare con la pistola
	ACTION_VERB ( AV_ANY_PLACE, SPARA, &Lohacker::OnSpara);
	ACTION_VERB_NOUN ( AV_ANY_PLACE, SPARA, CANE, "Come hai osato anche solo PENSARE di fare una cosa tanto orribile?.\n");
	ACTION_VERB_NOUN ( AV_ANY_PLACE, SPARA, AV_ANY_TERM, &Lohacker::OnSpara);
	
	// gestione dell'estrazione della pistola e del riporla in tasca
	ACTION_VERB_NOUN ( AV_ANY_PLACE, PRENDI, PISTOLA, &Lohacker::OnPrendiPistola);
	ACTION_VERB_NOUN ( AV_ANY_PLACE, ESTRAI, PISTOLA, &Lohacker::OnEstraiPistola);

	ACTION_VERB_NOUN ( AV_ANY_PLACE, LASCIA, PISTOLA, &Lohacker::OnLasciaPistola);
	ACTION_VERB_NOUN ( AV_ANY_PLACE, RIPONI, PISTOLA, &Lohacker::OnNascondiPistola);
	ACTION_THREE ( AV_ANY_PLACE, RIPONI, PISTOLA, TASCA, &Lohacker::OnNascondiPistola);
	ACTION_THREE ( AV_ANY_PLACE, METTI, PISTOLA, TASCA, &Lohacker::OnNascondiPistola);
	ACTION_THREE ( AV_ANY_PLACE, RIPONI, TASCA, PISTOLA,&Lohacker::OnNascondiPistola);
	ACTION_THREE ( AV_ANY_PLACE, METTI, TASCA, PISTOLA, &Lohacker::OnNascondiPistola);

	// 2 timer x lo schifido
	design.AddTimer(TIMER_ARRIVA_SCHIFIDO);
	ACTION_TIMER_ELAPSED( TIMER_ARRIVA_SCHIFIDO, &Lohacker::OnArrivaSchifido );
	design.AddTimer(TIMER_SCHIFIDO);
	ACTION_TIMER_ELAPSED( TIMER_SCHIFIDO, &Lohacker::OnElapsedTimerSchifido );

	// gestione del paravento e dell'effetto sorpresa
	design.AddIntegerVariable(SORPRESA, 0);

	design.AddLocation(DIETRO_IL_PARAVENTO, "Ti trovi dietro al paravento.", 
				"Ti aspettavi chissa' che cosa, e invece dietro al paravento non c'e'\n"
				"proprio niente. Pero' questo sembra un buon posto per nascondersi...",
				AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID, AV_INVALID);

	// andare dietro al paravento / uscire dal paravento
	ACTION_VERB_NOUN ( LOVE_ROOM, VAI_VERSO, PARAVENTO, &Lohacker::OnVaiDietroParavento);
	ACTION_VERB_NOUN ( LOVE_ROOM, ENTRA, PARAVENTO, &Lohacker::OnVaiDietroParavento);
	ACTION_VERB_NOUN ( LOVE_ROOM, NASCONDITI, PARAVENTO, &Lohacker::OnVaiDietroParavento);

	ACTION_VERB_NOUN ( DIETRO_IL_PARAVENTO, VAI_VERSO, PARAVENTO, "Sono gia' dietro al paravento.");
	ACTION_VERB_NOUN ( DIETRO_IL_PARAVENTO, ENTRA, PARAVENTO, "Sono gia' dietro al paravento.");
	ACTION_VERB_NOUN ( DIETRO_IL_PARAVENTO, NASCONDITI, PARAVENTO, "Sono gia' dietro al paravento.");
	ACTION_VERB ( DIETRO_IL_PARAVENTO, NASCONDITI, "Direi che questo e' gia' un bel nascondiglio.");

	ACTION_VERB_NOUN ( DIETRO_IL_PARAVENTO, ESCI, PARAVENTO, &Lohacker::OnEsciParavento);
	ACTION_VERB (DIETRO_IL_PARAVENTO, ESCI, &Lohacker::OnEsciParavento);
	ACTION_VERB (DIETRO_IL_PARAVENTO, VAI_NORD, &Lohacker::OnEsciParavento);
	ACTION_VERB (DIETRO_IL_PARAVENTO, VAI_SUD, &Lohacker::OnEsciParavento);
	ACTION_VERB (DIETRO_IL_PARAVENTO, VAI_EST, &Lohacker::OnEsciParavento);
	ACTION_VERB (DIETRO_IL_PARAVENTO, VAI_OVEST, &Lohacker::OnEsciParavento);

	ACTION_VERB_NOUN ( LOVE_ROOM, GUARDA, PARAVENTO, "Non ci vedo niente di speciale...\n"
						"Forse, dietro c'e' qualcosa di interessante!");
	ACTION_VERB_NOUN ( DIETRO_IL_PARAVENTO, GUARDA, PARAVENTO, 
		"E' tutto rosso, decorato con immagini di camaleonti verdi.\nA parte quello, non ci vedo PROPRIO NIENTE di speciale!");

	// gestione di default del verbo "nasconditi"
	ACTION_VERB ( AV_ANY_PLACE, NASCONDITI, "Buona idea, ma dove mi nascondo?");
	ACTION_VERB_NOUN ( AV_ANY_PLACE, NASCONDITI, AV_ANY_TERM, "No, direi che sei fuori strada.");

	// gestione di default del verbo "leggi"
	ACTION_VERB_NOUN(AV_ANY_PLACE, LEGGI, AV_ANY_TERM, "Non c'e' niente da leggere.");
	ACTION_VERB (AV_ANY_PLACE, LEGGI, "Che cosa?");
}


void Lohacker::OnVaiDietroParavento()
{
	// inutile scappare se lo schifido e' gia' arrivato
	if(Timers(TIMER_SCHIFIDO).IsActive())
	{
		Io().Write("Tenti di scappare nascondendoti dietro al paravento... ma... \n");
		Io().WaitForEnter();
		OnElapsedTimerSchifido();
	}
	else
		MoveTo(DIETRO_IL_PARAVENTO);
}

void Lohacker::OnEsciParavento()
{
	MoveTo(LOVE_ROOM);
	if(Timers(TIMER_SCHIFIDO).IsActive())
	{
		// una sola mossa, di sorpresa
		Timers(TIMER_SCHIFIDO).SetTime(2);
		IntegerVariables(SORPRESA) = 1;

		Io().Write("Balzi fuori all'improvviso dal tuo nascondiglio, pronto a cogliere di sorpresa\n"
			"i tuoi nemici... Lo spettacolo che ti si presenta davanti e' spaventoso.\n");
		Io().WaitForEnter();
		Io().Write("Un gigantesco pinguino mutante avanza a grandi passi nella stanza.\n"
				"Accanto al portale si trova invece un essere meta' uomo e meta' gatto.\n"
				"Lo riconosci, l'hai visto su mille manifesti: e' un lamer pluriricercato...\n");
		Io().WaitForEnter();
		Io().Write("... lo SCHIFIDO !!!\n");
		Io().WaitForEnter();
	}
}


void Lohacker::OnSpara()
{
	if (Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		Io().Write("Non ne ho voglia. Dammi un bersaglio interessante su cui sparare.\n");
	}
	else
	{
		Io().Write("Senza una pistola non puoi sparare!\n");
	}
}

void Lohacker::OnSparaSchifido()
{
	if (Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		if(IntegerVariables(PISTOLA_IN_PUGNO))
		{
			if(IntegerVariables(SORPRESA))
			{
				Io().Write("Premi il grilletto. Un violento sparo echeggia nella stanza...\n");
				Io().WaitForEnter();
				Io().Write("Lo Schifido, colto di sorpresa, cade al suolo in una pozza di sangue...\n");
				Io().WaitForEnter();
				Io().Write("... tenta di rialzarsi... ci riesce, spicca un ultimo balzo verso di te,\n"
					"pronto a colpire con i suoi artigli micidiali...\n");
				Io().WaitForEnter();
				Io().Write("Ma gli spari un'altra volta, e stavolta muore sul serio.\n");
				Io().WaitForEnter();
				Objects(SCHIFIDO).MoveTo(AV_LIMBO);
				IntegerVariables(SORPRESA) = 0;
				Timers(TIMER_SCHIFIDO).SetTime(3);
			}
			else
			{
				Io().Write("Stai per premere il grilletto...\n");
				Io().WaitForEnter();
				Io().Write("...ma Tuxenstein aveva visto la pistola, e si aspettava questa mossa.\n");
				Io().WaitForEnter();
				Io().Write("In un attimo il pinguino ti e' addosso e ti blocca il braccio.\n"
					"Poi con una sola zampata ti spedisce all'altro mondo.\n");
				Io().WaitForEnter();
				LoseGame();
			}
		}
		else
		{
			Io().Write("Dove hai messo la pistola? Non ricordi piu' in quale tasca...\n"
					"...e naturalmente la prima che provi e' sempre quella sbagliata.\nEccola!\n");
			Io().WaitForEnter();
			Io().Write("Ma e' troppo tardi!\n");
			Timers(TIMER_SCHIFIDO).SetTime(1);
		}
	}
	else
	{
		Io().Write("Senza una pistola non puoi sparare!\n");
	}
}


void Lohacker::OnSparaTux()
{
	if (Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		if(IntegerVariables(PISTOLA_IN_PUGNO))
		{
			Io().Write("Premi il grilletto. Un violento sparo echeggia nella stanza...\n");
			Io().WaitForEnter();
			if(IntegerVariables(SORPRESA))
			{
				Io().Write("Tuxenstein, colto di sorpresa, cade al suolo in una pozza di sangue.\n");
				Io().WaitForEnter();
				Io().Write("Sul volto dello Schifido appare un'espressione d'orrore:\n"
					"- No! La mia creaturaaaaaa!\n");
				Io().WaitForEnter();
				Io().Write("Il cadavere di Tuxenstein inzia a trasformarsi...\n"
					"sembra quasi che stia diventando un pinguino normale...\n"
					"un tremendo sospetto si fa strada nella tua mente.\n");
				Io().WaitForEnter();
				Io().Write("Ma non hai tempo di formularlo: lo Schifido e' alle tue spalle,sfodera\n"
					"artigli affilatissimi... e li pianta nel tuo cuore.\n");
				LoseGame();
			}
			else
			{
				Io().Write("...ma Tuxenstein aveva visto la pistola, e si aspettava questa mossa.\n");
				Io().WaitForEnter();
				Io().Write("Non hai il tempo per renderti conto di averlo mancato.\n"
					"Con una zampata ben decisa il pinguino ti spedisce all'altro mondo.\n");
				Io().WaitForEnter();
				LoseGame();
			}
		}
		else
		{
			Io().Write("Dove hai messo la pistola? Non ricordi piu' in quale tasca...\n"
					"...e naturalmente la prima che provi e' sempre quella sbagliata.\nEccola!\n");
			Io().WaitForEnter();
			Io().Write("Ma e' troppo tardi!\n");
			Timers(TIMER_SCHIFIDO).SetTime(1);
		}
	}
	else
	{
		Io().Write("Senza una pistola non puoi sparare!\n");
	}
}




void Lohacker::OnAttaccaSchifido()
{
	if (Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		OnSparaSchifido();
	}
	else
	{
		Io().Write("Tenti di ammazzare lo Schifido a mani nude, ma e' troppo agile e veloce.\n"
			"Mentre cerchi di colpirlo, Tuxenstein ti e' addosso e ti uccide in un sol colpo.\n");
		LoseGame();
	}
}

void Lohacker::OnAttaccaTux()
{
	if (Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		OnSparaTux();
	}
	else
	{
		Io().Write("Tenti di ammazzare Tuxenstein a mani nude, ma e' troppo forte.\n"
			"Senza alcuna fatica, ti uccide in un sol colpo.\n");
		LoseGame();
	}
}

void Lohacker::OnElapsedTimerSchifido()
{
	if (GetLocationID() == LOVE_ROOM)
	{
		Io().Write("\nTuxenstein e' ormai vicinissimo e ti attacca senza esitazione.\n");
	}
	else
	{
		Io().Write("\nNascondersi e' stato inutile... Il nemico ti ha individuato!\n");
		Io().Write("Il paravento si squarcia in due, e un gigantesco pinguino mutante\nsi getta verso di te.\n");
	}
	Io().Write("Non hai alcuna speranza, e soccombi in un bagno di sangue.\n");
	LoseGame();
}

void Lohacker::OnArrivaSchifido()
{
	if (GetLocationID() == LOVE_ROOM)
	{
		Io().Write("\nLa porta della cella si schianta con un enorme fragore.\n");
		Io().Write("\nDal buio emerge una figura minacciosa... i suoi occhi sono\n"
			"iniettati di sangue... e' un gigantesco, terribile...\n");
		Io().WaitForEnter();
		Io().Write("... PINGUINO MUTANTE !\n");
		Io().WaitForEnter();

		Io().Write("Stai per svenire dall'orrore, ma il peggio deve ancora arrivare.\n"
				"Una voce si ode all'improvviso alle tue spalle:\n"
				"- Un lohacker, eh? Sei arrivato giusto in tempo per assistere al mio esperimento!\n");
		Io().WaitForEnter();
		Io().Write("Ti volti di scatto, e ti trovi davanti una creatura ancora piu'ripugnante:\n"
			"sembra un uomo, ma ha grandi orecchie e baffi da gatto, e la sua voce sembra un\n"
			"viscido miagolio.\n");
		Io().WaitForEnter();

		Io().Write("Il sangue ti si gela: lo hai riconosciuto. L'hai visto su mille manifesti:\n"
			"e' un lamer pluriricercato, il terrore di tutti i lohacker...\n");
		Io().WaitForEnter();
		Io().Write("... e' lo SCHIFIDO !!!\n");
		Io().WaitForEnter();
		Io().Write("- Sorgi! - grida il lamer - Sorgi alla vita, TUXENSTEIN !!!\n");
	}
	else
	{
		// sei dietro il paravento
		Io().Write("\nSenti il fragore della porta della cella che si schianta.\n");
		Io().Write("\nPassi pesanti echeggiano nella stanza, dietro il paravento...\n");
		Io().WaitForEnter();
		Io().Write("Una voce viscida miagola qualcosa come:\n"
			"- Sorgi alla vita, TUXENSTEIN !!!\n");
	}
	Io().WaitForEnter();
	Objects(CELLA).MoveTo(AV_LIMBO);
	Objects(SCHIFIDO).MoveTo(LOVE_ROOM);
	Objects(TUX).MoveTo(LOVE_ROOM);
	Timers(TIMER_SCHIFIDO).SetTime(4);
}

void Lohacker::OnPrendiPistola()
{
	if(Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		if(IntegerVariables(PISTOLA_IN_PUGNO))
		{
			Io().Write("L'hai gia' in pugno.\n");
		}
		else
		{
			Io().Write("Dove hai messo la pistola? Non ricordi piu' in quale tasca...\n"
					"...e naturalmente la prima che provi e' sempre quella sbagliata.\nEccola!\n");
			Io().WaitForEnter();
			IntegerVariables(PISTOLA_IN_PUGNO) = 1;
		}
	}
	else
	{
		if(GetLocationID() == STUDIO)
		{
			Io().Write("Ma chi e' quel pazzo che lascia una pistola carica in bella vista\nsu una scrivania?\n");
		}
		else
		{
			Io().Write("Ok.");
		}
		Objects(PISTOLA).MoveTo(AV_INVENTORY);
		/* Questo semplifica troppo la vita al giocatore.
		devi inventarti una frase apposta
		if(Io().ReadYesNo("Se vuoi che la tenga in pugno, dimmi SI.\nSe vuoi che la tenga in tasca, dimmi NO.\n"))
		{
			IntegerVariables(PISTOLA_IN_PUGNO) = 1;
		} Meglio questo: */ 
		IntegerVariables(PISTOLA_IN_PUGNO) = 1;
	}
}

void Lohacker::OnLasciaPistola()
{
	if(Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		if(IntegerVariables(PISTOLA_IN_PUGNO))
		{
			if(Io().ReadYesNo("Se vuoi che la metta in tasca, dimmi SI.\nSe vuoi che la lasci per terra, dimmi NO.\n"))
			{
				IntegerVariables(PISTOLA_IN_PUGNO) = 0;
			}
			else
			{
				IntegerVariables(PISTOLA_IN_PUGNO) = 0;
				Objects(PISTOLA).MoveTo(GetLocationID());
			}
			Io().Write("Ok.");
		}
		else
		{
				Objects(PISTOLA).MoveTo(GetLocationID());
				Io().Write("Ok.");
		}
	}
	else
	{
		Io().Write("Non l'hai con te\n.");
	}
}

// come i due comandi precedenti, ma piu' precisi, qui sai per certo cosa vuoi
// fare con la pistola

void Lohacker::OnEstraiPistola()
{
	if(Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		if(IntegerVariables(PISTOLA_IN_PUGNO))
		{
			Io().Write("L'hai gia' in pugno.\n");
		}
		else
		{
			Io().Write("Dove hai messo la pistola? Non ricordi piu' in quale tasca...\n"
					"...e naturalmente la prima che provi e' sempre quella sbagliata.\nEccola!\n");
			Io().WaitForEnter();
			IntegerVariables(PISTOLA_IN_PUGNO) = 1;
		}
	}
	else
	{
		Io().Write("Prima devi prenderla.\n");
	}
}

void Lohacker::OnNascondiPistola()
{
	if(Objects(PISTOLA).GetLocationID() == AV_INVENTORY)
	{
		if(IntegerVariables(PISTOLA_IN_PUGNO))
		{
			IntegerVariables(PISTOLA_IN_PUGNO) = 0;
			Io().Write("Ok.");
		}
		else
		{
			Io().Write("E' gia' in tasca.\n");
		}
	}
	else
	{
		Io().Write("Non l'hai con te.\n");
	}
}

bool Lohacker::OnBeforeLocationDesc()
{
	if(IntegerVariables(PISTOLA_IN_PUGNO) && GetLocationID() == INGRESSO)
	{
		Io().Write("\nSei nell'ingresso.\nIl cane vede che hai in mano una pistola...\n");
		Io().WaitForEnter();
		Io().Write("... non sapendo se sei un nemico oppure no, pensa bene di attaccarti.\n");
		Io().Write("Tenti di reagire, ma la pistola ti cade, e sei alla merce' di questo tenero cucciolo...\n");
		Io().WaitForEnter();
		Io().Write("... che ti uccide senza esitazione.\n");
		LoseGame();
		return false;
	}
	return true;
}


void Lohacker::OnAfterLocationDesc()
{
	if(IntegerVariables(PISTOLA_IN_PUGNO))
	{
		Io().Write("\nHai la pistola in pugno.\n");
	}
	// cose che succedono nella love room
	if (GetLocationID() == LOVE_ROOM)
	{
		switch(Timers(TIMER_ARRIVA_SCHIFIDO).GetTime())
		{
		case 3 :
			Io().Write("\nE' una tua impressione o la stanza sta diventando piu' buia?\n");
			break;
		case 2 :
			Io().Write("\nSenti un verso raccapricciante provenire dalla cella...\n");
			break;
		case 1 :
			Io().Write("\nQualcosa afferra le sbarre dall'interno, e inizia a scuoterle forte...\n");
			break;
		}
	}
	// cose che succedono mentre sei nascosto
	if (GetLocationID() == DIETRO_IL_PARAVENTO)
	{
		switch(Timers(TIMER_ARRIVA_SCHIFIDO).GetTime())
		{
		case 3 :
			Io().Write("\nE' una tua impressione o la stanza sta diventando piu' buia?\n");
			break;
		case 2 :
			Io().Write("\nSenti un verso raccapricciante, forse viene dalla cella!\n");
			break;
		case 1 :
			Io().Write("\nLa tensione sale. Non capisci cosa sta per accadere...\n");
			Io().Write("... capisci solo che sei in pericolo!\n");
			break;
		}
	}
}

void Lohacker::OnPrendiPolloInCucina()
{
	if (Objects(POLLO).GetStateID() == IN_COTTURA)
	{
		Io().Write("No! Sta cuocendo!\n");
	}
	else
	{
		PickupObject();
	}
}

void Lohacker::OnMangiaPollo()
{
	if(Objects(POLLO).GetStateID() == COTTO)
	{
		Io().Write("Mangi il pollo, e di gusto pure!!!\n");
		Io().WaitForEnter();
		Io().Write("Un momento! C'e' qualcosa dentro il pollo! Una chiave!\n");
		Objects(POLLO).MoveTo(AV_LIMBO);
		Objects(CHIAVE).MoveTo(GetLocationID());
	}
	else if (Objects(POLLO).GetStateID() == IN_COTTURA)
		Io().Write("No! Sta cuocendo!\n");
	else
		Io().Write("Non lo voglio, e' crudo!!!\n");
}

void Lohacker::OnApriArmadio()
{
	if(Objects(ARMADIO).GetStateID() == APERTA)
		Io().Write("E' gia' aperto!\n");
	else
	{
		Objects(ARMADIO).SetState(APERTA);
		Io().Write("Dentro l'armadio c'e' un pollo!\n");
		Objects(POLLO).MoveTo(DISPENSA);
	}
}


void Lohacker::OnCuociPollo()
{
	switch(Objects(POLLO).GetStateID())
	{
		case COTTO : Io().Write("E' gia' cotto!\n"); break;
		case IN_COTTURA : Io().Write("Sta cuocendo...\n"); break;
		default :
			Io().Write("Dando prova di grande abilita' culinaria, prepari un ottimo pollo arrosto...\n");
			Objects(POLLO).SetState(IN_COTTURA);
			Objects(POLLO).MoveTo(CUCINA);
			Timers(TIMER_POLLO).SetTime(11);
	}
}


void Lohacker::OnAspettaSpecial()
{
	// aspetta, poi setta il timer del pollo a 1,
	// cosi' al prossimo ciclo scattera'.
	WasteTime();
	if(Timers(TIMER_POLLO).IsActive())
	{
		Timers(TIMER_POLLO).SetTime(1);
	}
}

void Lohacker::OnPolloPronto()
{
	switch(GetLocationID())
	{
	case CUCINA:
		Io().Write("*Ding!*\nIl pollo e' pronto!\n");
		break;
	case INGRESSO:
	case DISPENSA:
	case LOVE_ROOM:
		Io().Write("Ho sentito un *Ding!*\nVeniva dalla cucina...\n");
		break;
	default:
		Io().Write("Ho sentito un *Ding!*\nVeniva dal piano di sotto...\n");
	}
	Objects(POLLO).SetState(COTTO);
}



void Lohacker::OnMoveWest()
{
	if(GetLocationID() == INGRESSO && Objects(PORTALE).GetStateID() != APERTA)
	{
		Io().Write("Il portale e' chiuso: non puoi passare.\n");
	}
	else
	{
		AvalonGame::OnMoveWest();
	}
}

void Lohacker::OnMoveNorth()
{
	if(GetLocationID() == PIANEROTTOLO && Objects(PORTA).GetStateID() != APERTA)
	{
		Io().Write("La porta e' chiusa: non puoi passare.\n");
	}
	else
	{
		AvalonGame::OnMoveNorth();
	}
}

void Lohacker::OnMoveEast()
{
	if(GetLocationID() == INGRESSO)
	{
		Io().Write("Attenzione, di qua c'e' l'uscita! Se scappi...\n\n");
		if(Io().ReadYesNo("Vuoi davvero uscire dalla villa? (S/N)"))
		{
			Io().Write("Scappi, e abbandoni la missione.\n");
			Io().Write("Il Conte non te lo perdonera'... lo sapevi che ha una morbosa\n"
				"passione per la ghigliottina?\n");
			LoseGame();
		}
	}
	else if (GetLocationID() == LOVE_ROOM && Objects(PORTALE).GetStateID() != APERTA)
	{
		Io().Write("Il portale e' chiuso: non puoi passare.\n");
	}
	else
	{
		AvalonGame::OnMoveEast();
	}
}

void Lohacker::OnCoccoleCane()
{
	Io().Write("Ti avvicini al cane per accarezzarlo... e lui...\n");
	Io().WaitForEnter();
	Io().Write("... apprezza le coccole, scodinzola e fa le feste!\n");
	if(Objects(PORTALE).GetStateID() != APERTA)
	{
		Io().WaitForEnter();
		Io().Write("Per ringraziarti, il cane si avvicina al portale, ed emette\ndegli strani guaiti.\n");
		Io().Write("Sembra quasi una specie di codice segreto...\n");
		Io().WaitForEnter();
		Io().Write("... improvvisamente il portale si apre!\n");
		Io().WaitForEnter();
		Objects(PORTALE).SetState(APERTA);
	}
}

void Lohacker::OnApriStudio()
{
	if(Objects(PORTA).GetStateID() != APERTA)
	{
		if(Objects(CHIAVE).GetLocationID() == AV_INVENTORY)
		{
			Io().Write("Adesso e' aperta!\n");
			Objects(PORTA).SetState(APERTA);
		}
		else
			Io().Write("Non hai la chiave per questa porta.\n");
	}
	else
		Io().Write("E' gia' aperta!\n");
}

void Lohacker::OnApriLibro()
{
	Io().Write("Una pagina ti colpisce: rappresenta un uomo con lunghi e disordinati capelli\n");
	Io().Write("neri e barba da rabbino, ma vestito con un abito da mago medievale.\n");
	Io().Write("Sotto c'e' scritto, in caratteri gotici:\n\tGNU IS NOT UNIX\n");
	Io().Write("Chissa' che cosa significa...\n");
	/*bGrifondoro = true;*/
	IntegerVariables(CONOSCI_GRIFONDORO) = 1;
}

void Lohacker::OnGrifondoro()
{
	if(GetLocationID() == LOVE_ROOM && Objects(PORTALE).GetStateID() != APERTA)
	{
		Io().Write("Pronunci l'incantesimo, ma non succede niente.\n");
		return;
	}
	
	if(IntegerVariables(CONOSCI_GRIFONDORO))
	{
		Io().Write("Pronunci solennemente l'incantesimo...\n");
		Io().Wait(2);
		if (GetLocationID() == LOVE_ROOM)
		{
			Io().Write("Non succede niente. Forse non e' il luogo adatto.\n");
			Io().Wait(2);
			Io().Write("Un momento...");
			Io().Wait(1);
			Io().Write(" cos'era quel rumore alle tue spalle?\n");
			Io().WaitForEnter();
			Io().Write("Il portale si e' chiuso!\n");
			Io().Write("SEI IN TRAPPOLA!\n");
			Io().WaitForEnter();
			Timers(TIMER_ARRIVA_SCHIFIDO).SetTime(4);
			Objects(PORTALE).SetState(AV_INITIAL);
		}
		else
		{
			Io().Write("Non succede niente. Forse non e' il luogo adatto.\n");
			Io().Wait(2);
		}
	}
	else
	{
		Io().Write("Ammesso che sia una formula magica, tu ancora non la conosci!\n");
	}
}

void Lohacker::OnGuardaFicus()
{
	Io().Write("E' una normalissima pianta di ficus.\n"
			"Sul vaso sono incise delle parole arcane:\n"
			"\tLOGICIEL LIBRE\n");
	IntegerVariables(CONOSCI_LIBRE) = 1;
}

void Lohacker::OnLogicielLibre()
{
	if(IntegerVariables(CONOSCI_LIBRE))
	{
		Io().Write("Pronunci solennemente l'incantesimo...\n");
		Io().Wait(2);

		if (GetLocationID() == LOVE_ROOM && Objects(TUX).GetLocationID() == LOVE_ROOM)
		{
			Io().Write("Improvvisamente l'enorme pinguino arresta la sua avanzata.\n");
			if(Objects(SCHIFIDO).GetLocationID() == LOVE_ROOM)
			{
				Io().Write("Sul volto dello Schifido appare un'espressione d'orrore:\n"
					"- No! La mia creaturaaaaaa!\n");
				Io().WaitForEnter();
				Io().Write("Tuxenstein inzia a trasformarsi...\n"
						"sembra quasi che stia diventando un pinguino normale...\n"
						"un sospetto si fa strada nella tua mente.\n");
				Io().WaitForEnter();
				Io().Write("Ma non hai tempo di formularlo: lo Schifido e' alle tue spalle,sfodera\n"
					"artigli affilatissimi... e ti recide la giugulare.\n");
				LoseGame();
			}
			else
			{
				Io().Write("Tuxenstein inzia a trasformarsi...\n"
						"sembra quasi che stia diventando un pinguino normale...\n");
				Io().WaitForEnter();
				Io().Write("Incredibile! Ma e' il tuo caro amico Tux, il pinguino volante,\n"
						"compagno di mille avventure!\n");
				Io().WaitForEnter();
				WinGame();
			}
		}
		else
		{
			Io().Write("Non succede niente. Forse non e' il luogo o il momento giusto.\n");
		}
	}
	else
	{
		Io().Write("Ammesso che sia una formula magica, tu ancora non la conosci!\n");
	}
}


void Lohacker::OnWin()
{
	Io().Write("Con la sua grande forza, Tux abbatte il portale, cosi potete fuggire\n"
		"dalla villa maledetta.\n"
		"Come ai vecchi tempi, salti in groppa al tuo amico e volate via...\n"
		"... svanendo all'orizzonte, nel cuore della notte...\n");

	Io().WaitForEnter();
	Io().Write("\nIl gioco e' finito: congratulazioni, hai vinto!\n");
}

void Lohacker::OnLose()
{
	Io().Write("\nSei morto. La comunita' dei lohacker ha perso un altro incapace.\n");
}


int main(int argc, char** argv)
{
	Lohacker z;
	z.Run();
	return 0;
}
